Subject: Re: B19.1: memcpy bug (NT)
From: [email-masked] (Vincent S. Perun)

26 Aug 1998 11:55:09 -0700
Message-ID: <[email-masked]>
References: <[email-masked]>
Mime-Version: 1.0
Content-Type: TEXT/PLAIN; charset=US-ASCII
To: [email-masked]

Hello, everyone: I got the message!  The bug was in my internal processor
(grey matter).  It must be time for a vacation.  I know better:  I used to
work with DEC VAX machines which are also little endian.  I've been staring
into the SUNs too long!

Vincent Perun

On Fri, 21 Aug 1998, Vincent S. Perun wrote:

> Hello.  I've discovered a bug with memcpy under beta 19.1 and NT 4.0.  It
> seems the contents of a char array don't copy into an int in the right order:
> The bytes are reversed!  This test expects the output to be "ABCD" but it
> puts out "CDAB".  A char to char memcpy works just fine!
> 
> Vincent Perun
> 
> Test program:
> 
> main()
> {
>    unsigned char s1[2] = {0xAB, 0xCD};
>    unsigned short n;
>    unsigned char s2[2];
> 
>    memcpy (&n, &s1, 2);
>    printf ("n: %4.4X\n", n);
>    memcpy (&s2, &s1, 2);
>    printf ("s2: %2.2X%2.2X\n", s2[0], s2[1]);
> }
> 
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".